#include <stdint.h>

uint8_t diskstream[2][35][6656];

uint8_t sector62[343];

uint8_t valid_nibbles[64]=
{
 0x96, 0x97, 0x9A, 0x9B, 0x9D, 0x9E, 0x9F, 0xA6, 
 0xA7, 0xAB, 0xAC, 0xAD, 0xAE, 0xAF, 0xB2, 0xB3,
 0xB4, 0xB5, 0xB6, 0xB7, 0xB9, 0xBA, 0xBB, 0xBC, 
 0xBD, 0xBE, 0xBF, 0xCB, 0xCD, 0xCE, 0xCF, 0xD3,
 0xD6, 0xD7, 0xD9, 0xDA, 0xDB, 0xDC, 0xDD, 0xDE, 
 0xDF, 0xE5, 0xE6, 0xE7, 0xE9, 0xEA, 0xEB, 0xEC,
 0xED, 0xEE, 0xEF, 0xF2, 0xF3, 0xF4, 0xF5, 0xF6, 
 0xF7, 0xF9, 0xFA, 0xFB, 0xFC, 0xFD, 0xFE, 0xFF
};

uint32_t slice6 (uint32_t input)
{
 uint8_t a[3], b[4];
 uint32_t c;
 
 a[0]=(input>>16)&0xFF;
 a[1]=(input>>8)&0xFF;
 a[2]=input&0xFF;
 
 /*
  * 876543·21 8765·4321 87·654321
  * 654321·65 4321·6543 21·654321
  */
 b[0]=(a[0]&0xFC)>>2;
 b[1]=((a[0]&0x03)<<4)|((a[1]&0xF0)>>4);
 b[2]=((a[1]&0x0F)<<2)|((a[2]&0xC0)>>6);
 b[3]=(a[3]&0x3F);
 
 c=b[0];
 c<<=8;
 c|=b[1];
 c<<=8;
 c|=b[2];
 c<<=8;
 c|=b[3];
 return c; 
}

uint32_t unslice6 (uint8_t *input)
{
 uint8_t a[4], b[3];
 uint32_t c;
 
 a[0]=(input>>24)&0xFF;
 a[1]=(input>>16)&0xFF;
 a[2]=(input>>8)&0xFF;
 a[3]=input&0xFF;
 
 /*
  * 00654321 0065·4321 006543·21 00654321
  *   876543   21·8765   4321·87   654321
  */
 
 b[0]=((a[0]&0x3F)<<2)|((a[1]&0x30)>>4);
 b[1]=((a[1]&0x0F)<<4)|((a[2]&0x3C)>>2);
 b[2]=((a[2]&0x03)<<6)|(a[3]&0x3F));
 
 c=b[0];
 c<<=8;
 c|=b[1];
 c<<=8;
 c|=b[2];
 return c;
}

int residisk_256to343 (uint8_t *input, uint8_t *output)
{
 uint16_t a, b;
 uint32_t c, d;
 uint8_t e[4];
 
 b=0;
 for (a=0; a<256; a+=3)
 {
  c=input[a];
  c<<=8;
  c|=input[a+1];
  c<<=8;
  c|=input[a+2];
  d=slice6(c);
  output[b++]=valid_nibbles[(d>>24)&0xFF];
  output[b++]=valid_nibbles[(d>>16)&0xFF];
  output[b++]=valid_nibbles[(d>>8)&0xFF];
  output[b++]=valid_nibbles[d&0xFF];
 }
}

